Package groovy.json

## Class StreamingJsonBuilder

- java.lang.Object
- - groovy.lang.GroovyObjectSupport
  - - groovy.json.StreamingJsonBuilder

- All Implemented Interfaces:
    `GroovyObject`

      public class StreamingJsonBuilder
      extends GroovyObjectSupport

  A builder for creating JSON payloads.

  This builder supports the usual builder syntax made of nested method calls and closures, but also some specific aspects of JSON data structures, such as list of values, etc. Please make sure to have a look at the various methods provided by this builder to be able to learn about the various possibilities of usage.

  Unlike the JsonBuilder class which creates a data structure in memory, which is handy in those situations where you want to alter the structure programatically before output, the StreamingJsonBuilder streams to a writer directly without any memory data structure. So if you don't need to modify the structure, and want a more memory-efficient approach, please use the StreamingJsonBuilder.

  Example:

           new StringWriter().with { w ->
               def builder = new groovy.json.StreamingJsonBuilder(w)
               builder.people {
                   person {
                       firstName 'Tim'
                       lastName 'Yates'
                       // Named arguments are valid values for objects too
                       address(
                           city: 'Manchester',
                           country: 'UK',
                           zip: 'M1 2AB',
                       )
                       living true
                       eyes 'left', 'right'
                   }
               }

               assert w.toString() == '{"people":{"person":{"firstName":"Tim","lastName":"Yates","address":{"city":"Manchester","country":"UK","zip":"M1 2AB"},"living":true,"eyes":["left","right"]}}}'
          }

  Since:
    1.8.1

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `StreamingJsonBuilder.StreamingJsonDelegate` | The delegate used when invoking closures

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StreamingJsonBuilder​(Writer writer)` | Instantiates a JSON builder.
    `StreamingJsonBuilder​(Writer writer, JsonGenerator generator)` | Instantiates a JSON builder with the given generator.
    `StreamingJsonBuilder​(Writer writer, Object content)` | Instantiates a JSON builder, possibly with some existing data structure.
    `StreamingJsonBuilder​(Writer writer, Object content, JsonGenerator generator)` | Instantiates a JSON builder, possibly with some existing data structure and the given generator.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Object` | `call​(Closure c)` | A closure passed to a JSON builder will create a root JSON object
    `Object` | `call​(Iterable coll, Closure c)` | A collection and closure passed to a JSON builder will create a root JSON array applying the closure to each object in the collection
    `Object` | `call​(Object... args)` | Varargs elements as arguments to the JSON builder create a root JSON array
    `void` | `call​(String name)` | The empty args call will create a key whose value will be an empty JSON object:
    `void` | `call​(String name, Closure c)` | A name and a closure passed to a JSON builder will create a key with a JSON object
    `void` | `call​(String name, Iterable coll, Closure c)` | A name, a collection and closure passed to a JSON builder will create a root JSON array applying the closure to each object in the collection
    `void` | `call​(String name, Collection coll, Closure c)` | Delegates to `call(String, Iterable, Closure)`
    `void` | `call​(String name, Map map, Closure callable)` | If you use named arguments and a closure as last argument, the key/value pairs of the map (as named arguments) and the key/value pairs represented in the closure will be merged together — the closure properties overriding the map key/values in case the same key is used.
    `Object` | `call​(Collection coll, Closure c)` | Delegates to `call(Iterable, Closure)`
    `Object` | `call​(List l)` | A list of elements as arguments to the JSON builder creates a root JSON array
    `Object` | `call​(Map m)` | Named arguments can be passed to the JSON builder instance to create a root JSON object
    `Object` | `invokeMethod​(String name, Object args)` | A method call on the JSON builder instance will create a root object with only one key whose name is the name of the method being called.

    - ### Methods inherited from class groovy.lang.GroovyObjectSupport

      `getMetaClass, getProperty, setMetaClass, setProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StreamingJsonBuilder

          public StreamingJsonBuilder​(Writer writer)

      Instantiates a JSON builder.
      Parameters:
        `writer` - A writer to which Json will be written

    - #### StreamingJsonBuilder

          public StreamingJsonBuilder​(Writer writer,
                                      JsonGenerator generator)

      Instantiates a JSON builder with the given generator.
      Parameters:
        `writer` - A writer to which Json will be written
        `generator` - used to generate the output
      Since:
        2.5.0

    - #### StreamingJsonBuilder

          public StreamingJsonBuilder​(Writer writer,
                                      Object content)
                               throws IOException

      Instantiates a JSON builder, possibly with some existing data structure.
      Parameters:
        `writer` - A writer to which Json will be written
        `content` - a pre-existing data structure, default to null
      Throws:
        `IOException`

    - #### StreamingJsonBuilder

          public StreamingJsonBuilder​(Writer writer,
                                      Object content,
                                      JsonGenerator generator)
                               throws IOException

      Instantiates a JSON builder, possibly with some existing data structure and the given generator.
      Parameters:
        `writer` - A writer to which Json will be written
        `content` - a pre-existing data structure, default to null
        `generator` - used to generate the output
      Throws:
        `IOException`
      Since:
        2.5.0

  - ### Method Detail

    - #### call

          public Object call​(Map m)
                      throws IOException

      Named arguments can be passed to the JSON builder instance to create a root JSON object

      Example:

           new StringWriter().with { w ->
             def json = new groovy.json.StreamingJsonBuilder(w)
             json name: "Tim", age: 31

             assert w.toString() == '{"name":"Tim","age":31}'
           }

      Parameters:
        `m` - a map of key / value pairs
      Returns:
        a map of key / value pairs
      Throws:
        `IOException`

    - #### call

          public void call​(String name)
                    throws IOException

      The empty args call will create a key whose value will be an empty JSON object:

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json.person()

               assert w.toString() == '{"person":{}}'
           }

      Parameters:
        `name` - The name of the empty object to create
      Throws:
        `IOException`

    - #### call

          public Object call​(List l)
                      throws IOException

      A list of elements as arguments to the JSON builder creates a root JSON array

      Example:

           new StringWriter().with { w ->
             def json = new groovy.json.StreamingJsonBuilder(w)
             def result = json([1, 2, 3])

             assert result == [ 1, 2, 3 ]
             assert w.toString() == "[1,2,3]"
           }

      Parameters:
        `l` - a list of values
      Returns:
        a list of values
      Throws:
        `IOException`

    - #### call

          public Object call​(Object... args)
                      throws IOException

      Varargs elements as arguments to the JSON builder create a root JSON array

      Example:

           new StringWriter().with { w ->
             def json = new groovy.json.StreamingJsonBuilder(w)
             def result = json 1, 2, 3

             assert result instanceof List
             assert w.toString() == "[1,2,3]"
           }

      Parameters:
        `args` - an array of values
      Returns:
        a list of values
      Throws:
        `IOException`

    - #### call

          public Object call​(Iterable coll,
                             @DelegatesTo(value=StreamingJsonDelegate.class,strategy=1)
                             Closure c)
                      throws IOException

      A collection and closure passed to a JSON builder will create a root JSON array applying the closure to each object in the collection

      Example:

           class Author {
                String name
           }
           def authors = [new Author (name: "Guillaume"), new Author (name: "Jochen"), new Author (name: "Paul")]

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json authors, { Author author ->
                   name author.name
               }

               assert w.toString() == '[{"name":"Guillaume"},{"name":"Jochen"},{"name":"Paul"}]'
           }

      Parameters:
        `coll` - a collection
        `c` - a closure used to convert the objects of coll
      Throws:
        `IOException`

    - #### call

          public Object call​(Collection coll,
                             @DelegatesTo(value=StreamingJsonDelegate.class,strategy=1)
                             Closure c)
                      throws IOException

      Delegates to `call(Iterable, Closure)`
      Throws:
        `IOException`

    - #### call

          public Object call​(@DelegatesTo(value=StreamingJsonDelegate.class,strategy=1)
                             Closure c)
                      throws IOException

      A closure passed to a JSON builder will create a root JSON object

      Example:

           new StringWriter().with { w ->
             def json = new groovy.json.StreamingJsonBuilder(w)
             json {
                name "Tim"
                age 39
             }

             assert w.toString() == '{"name":"Tim","age":39}'
           }

      Parameters:
        `c` - a closure whose method call statements represent key / values of a JSON object
      Throws:
        `IOException`

    - #### call

          public void call​(String name,
                           @DelegatesTo(value=StreamingJsonDelegate.class,strategy=1)
                           Closure c)
                    throws IOException

      A name and a closure passed to a JSON builder will create a key with a JSON object

      Example:

           new StringWriter().with { w ->
             def json = new groovy.json.StreamingJsonBuilder(w)
             json.person {
                name "Tim"
                age 39
             }

             assert w.toString() == '{"person":{"name":"Tim","age":39}}'
           }

      Parameters:
        `name` - The key for the JSON object
        `c` - a closure whose method call statements represent key / values of a JSON object
      Throws:
        `IOException`

    - #### call

          public void call​(String name,
                           Iterable coll,
                           @DelegatesTo(value=StreamingJsonDelegate.class,strategy=1)
                           Closure c)
                    throws IOException

      A name, a collection and closure passed to a JSON builder will create a root JSON array applying the closure to each object in the collection

      Example:

           class Author {
                String name
           }
           def authors = [new Author (name: "Guillaume"), new Author (name: "Jochen"), new Author (name: "Paul")]

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json.people authors, { Author author ->
                   name author.name
               }

               assert w.toString() == '{"people":[{"name":"Guillaume"},{"name":"Jochen"},{"name":"Paul"}]}'
           }

      Parameters:
        `coll` - a collection
        `c` - a closure used to convert the objects of coll
      Throws:
        `IOException`

    - #### call

          public void call​(String name,
                           Collection coll,
                           @DelegatesTo(value=StreamingJsonDelegate.class,strategy=1)
                           Closure c)
                    throws IOException

      Delegates to `call(String, Iterable, Closure)`
      Throws:
        `IOException`

    - #### call

          public void call​(String name,
                           Map map,
                           @DelegatesTo(value=StreamingJsonDelegate.class,strategy=1)
                           Closure callable)
                    throws IOException

      If you use named arguments and a closure as last argument, the key/value pairs of the map (as named arguments) and the key/value pairs represented in the closure will be merged together — the closure properties overriding the map key/values in case the same key is used.

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json.person(name: "Tim", age: 35) { town "Manchester" }

               assert w.toString() == '{"person":{"name":"Tim","age":35,"town":"Manchester"}}'
           }

      Parameters:
        `name` - The name of the JSON object
        `map` - The attributes of the JSON object
        `callable` - Additional attributes of the JSON object represented by the closure
      Throws:
        `IOException`

    - #### invokeMethod

          public Object invokeMethod​(String name,
                                     Object args)

      A method call on the JSON builder instance will create a root object with only one key whose name is the name of the method being called. This method takes as arguments:
      - a closure
      - a map (ie. named arguments)
      - a map and a closure
      - or no argument at all

      Example with a classical builder-style:

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json.person {
                   name "Tim"
                    age 28
               }

               assert w.toString() == '{"person":{"name":"Tim","age":28}}'
           }

      Or alternatively with a method call taking named arguments:

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json.person name: "Tim", age: 32

               assert w.toString() == '{"person":{"name":"Tim","age":32}}'
           }

      If you use named arguments and a closure as last argument, the key/value pairs of the map (as named arguments) and the key/value pairs represented in the closure will be merged together — the closure properties overriding the map key/values in case the same key is used.

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json.person(name: "Tim", age: 35) { town "Manchester" }

               assert w.toString() == '{"person":{"name":"Tim","age":35,"town":"Manchester"}}'
           }

      The empty args call will create a key whose value will be an empty JSON object:

           new StringWriter().with { w ->
               def json = new groovy.json.StreamingJsonBuilder(w)
               json.person()

               assert w.toString() == '{"person":{}}'
           }

      Specified by:
        `invokeMethod` in interface `GroovyObject`
      Overrides:
        `invokeMethod` in class `GroovyObjectSupport`
      Parameters:
        `name` - the single key
        `args` - the value associated with the key
      Returns:
        the result of invoking the method